package gq.unurled.raxen.manager;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.utils.MongoDB;
import lombok.Getter;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;

import java.io.File;
import java.io.IOException;
import java.util.stream.IntStream;

import static gq.unurled.raxen.utils.Utils.error;
import static gq.unurled.raxen.utils.Utils.log;

public class StorageManager {

    private static Raxen main;
    private static FileConfiguration config;

    @Getter
    private static MongoDB mongo;
    @Getter
    private static String currently;

    public StorageManager(Raxen main) {
        this.main = main.getPlugin();
        this.config = main.getConfig();
    }

    public static void connect() {
        String s = (String) config.get("storage");
        switch(s) {
            case "MONGODB":
                mongo.connect();
                currently = s;
            case "MYSQL":
                error("Currently not implemented, switching to YML");
                currently = "YML";
            case "YML":
                currently = s;
        }
    }

    public static FileConfiguration createYml(Player player) {
        String name = player.getName();

        File customFile;
        FileConfiguration customConfig;
        log(main.getDataFolder() + "/" + player.getUniqueId() + "custom.yml");
        customFile = new File(main.getDataFolder() + "/" + player.getUniqueId(), "playerInfo.yml");

        if (!customFile.exists()) {
            customFile.getParentFile().mkdirs();
            main.saveResource("playerInfo.yml", false);
        }

        customConfig = new YamlConfiguration();
        try {
            customConfig.load(customFile);
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
        return customConfig;
    }

}